
/**
 * Classe concreta que representa um ponto com coordenadas inteiras.
 * Estende a classe abstracta ClusterElement, para que os pontos
 * podem ser agrupados em clusters.
 * 
 * @author Joo Carlos Pascoal Faria 
 * @version 6 de Fevereiro de 2003
 */
public class Point extends ClusterElement
{
    private int x;
    private int y;

    /**
     * Constri um ponto dadas as coordenadas
     * 
     * @param x  coordenada x
     * @param y  coordenada y
     */
    public Point(int x, int y)
    {
        this.x = x;
        this.y = y;
    }

    /**
     * Calcula a distancia a outro ponto, implementando assim
     * o mtodo abstracto definido em ClusterElement.
     * 
     * @param  p2   o outro ponto (formalmente do tipo
     *              ClusterElement, mas espera objecto do tipo Point)
     * @return      a distncia ao outro ponto 
     */
    public double distanceTo(ClusterElement elem2)
    {
        Point p2 = (Point)elem2;
        return Math.sqrt( (x-p2.x)*(x-p2.x) + (y-p2.y)*(y-p2.y) );
    }
    
    /**
     * Representa um ponto numa string 
     * @return uma string no formato (x, y)
     */
    public String toString()
    {
        return "(" + x + ", " + y + ")";
    }
}